WIP FPC-III support
[linux/fpc-iii.git] / tools / testing / selftests / net / forwarding / mirror_gre_flower.sh
blob09389f3b936946af6a6964f439718510df80fe77
1 #!/bin/bash
2 # SPDX-License-Identifier: GPL-2.0
4 # This test uses standard topology for testing gretap. See
5 # mirror_gre_topo_lib.sh for more details.
7 # This tests flower-triggered mirroring to gretap and ip6gretap netdevices. The
8 # interfaces on H1 and H2 have two addresses each. Flower match on one of the
9 # addresses is configured with mirror action. It is expected that when pinging
10 # this address, mirroring takes place, whereas when pinging the other one,
11 # there's no mirroring.
13 ALL_TESTS="
14 test_gretap
15 test_ip6gretap
18 NUM_NETIFS=6
19 source lib.sh
20 source mirror_lib.sh
21 source mirror_gre_lib.sh
22 source mirror_gre_topo_lib.sh
24 setup_prepare()
26 h1=${NETIFS[p1]}
27 swp1=${NETIFS[p2]}
29 swp2=${NETIFS[p3]}
30 h2=${NETIFS[p4]}
32 swp3=${NETIFS[p5]}
33 h3=${NETIFS[p6]}
35 vrf_prepare
36 mirror_gre_topo_create
38 ip address add dev $swp3 192.0.2.129/28
39 ip address add dev $h3 192.0.2.130/28
41 ip address add dev $swp3 2001:db8:2::1/64
42 ip address add dev $h3 2001:db8:2::2/64
44 ip address add dev $h1 192.0.2.3/28
45 ip address add dev $h2 192.0.2.4/28
48 cleanup()
50 pre_cleanup
52 ip address del dev $h2 192.0.2.4/28
53 ip address del dev $h1 192.0.2.3/28
55 ip address del dev $h3 2001:db8:2::2/64
56 ip address del dev $swp3 2001:db8:2::1/64
58 ip address del dev $h3 192.0.2.130/28
59 ip address del dev $swp3 192.0.2.129/28
61 mirror_gre_topo_destroy
62 vrf_cleanup
65 test_span_gre_dir_acl()
67 test_span_gre_dir_ips "$@" 192.0.2.3 192.0.2.4
70 fail_test_span_gre_dir_acl()
72 fail_test_span_gre_dir_ips "$@" 192.0.2.3 192.0.2.4
75 full_test_span_gre_dir_acl()
77 local tundev=$1; shift
78 local direction=$1; shift
79 local forward_type=$1; shift
80 local backward_type=$1; shift
81 local match_dip=$1; shift
82 local what=$1; shift
84 RET=0
86 mirror_install $swp1 $direction $tundev \
87 "protocol ip flower $tcflags dst_ip $match_dip"
88 fail_test_span_gre_dir $tundev $direction
89 test_span_gre_dir_acl "$tundev" "$direction" \
90 "$forward_type" "$backward_type"
91 mirror_uninstall $swp1 $direction
93 # Test lack of mirroring after ACL mirror is uninstalled.
94 fail_test_span_gre_dir_acl "$tundev" "$direction"
96 log_test "$direction $what ($tcflags)"
99 test_gretap()
101 full_test_span_gre_dir_acl gt4 ingress 8 0 192.0.2.4 "ACL mirror to gretap"
102 full_test_span_gre_dir_acl gt4 egress 0 8 192.0.2.3 "ACL mirror to gretap"
105 test_ip6gretap()
107 full_test_span_gre_dir_acl gt6 ingress 8 0 192.0.2.4 "ACL mirror to ip6gretap"
108 full_test_span_gre_dir_acl gt6 egress 0 8 192.0.2.3 "ACL mirror to ip6gretap"
111 test_all()
113 slow_path_trap_install $swp1 ingress
114 slow_path_trap_install $swp1 egress
116 tests_run
118 slow_path_trap_uninstall $swp1 egress
119 slow_path_trap_uninstall $swp1 ingress
122 trap cleanup EXIT
124 setup_prepare
125 setup_wait
127 tcflags="skip_hw"
128 test_all
130 if ! tc_offload_check; then
131 echo "WARN: Could not test offloaded functionality"
132 else
133 tcflags="skip_sw"
134 test_all
137 exit $EXIT_STATUS